import os, gettext, subprocess, gi, threading
gi.require_version('Gtk', '3.0')
from gi.repository import Caja, GObject, Gtk, GLib, Pango

import gettext

t = gettext.translation('copy_move_fm', "/usr/share/locale/")
t.install()
_ = t.gettext

class CopyToExplore(GObject.GObject, Caja.MenuProvider):
    '''Simple Caja extension to Send To Desktop files.'''

    def __init__(self):
        GObject.Object.__init__(self)

    # Choosing the file/directory
    def get_file_items(self, window, files):
        global filelist
        global pwd
        pwd = None
        filelist = []
        for file in files:
            if pwd == None:  # first file: find path to directory
                pwd = file.get_parent_location().get_path()
            name = file.get_name()
            filelist += [name]

        if pwd == None or len(filelist) == 0:
            return

        # Make sure that the user has write permissions in this directory
        elif not os.access(pwd, os.W_OK):
            return
        text = _("Copy to ...")
        # action for file(s) and directory(ies)
        item = Caja.MenuItem(
            name='CopyToExplore::Copy_to_explore',
            label=text,
            tip=text,
                        icon=""
        )
        item.connect('activate', self.copy_file, file)
        return [item]


    def copy_file(self, menu, file):
        win = InfoClass()
        dest = win.choose_folder_dialog(self)
        if dest != "":
            for filename in filelist:
                path = pwd + "/" + filename
                if path == f"{dest}/{filename}":
                    text = _("Attempt to copy to current directory")
                    win.print_error(text)
                elif os.path.exists(f"{dest}/{filename}"):
                    cmd = ["/usr/bin/cp", "-rf", path, f"{dest}"]
                    win = Async_gui(cmd, True)
                    win.connect("destroy", Gtk.main_quit)
                    win.show_all()
                    Gtk.main()
                else:
                    cmd = ["/usr/bin/cp", "-r", path, f"{dest}"]
                    win = Async_gui(cmd, False)
                    win.connect("destroy", Gtk.main_quit)
                    win.show_all()
                    Gtk.main()
                    # subprocess.call(cmd)

class MoveToExplore(GObject.GObject, Caja.MenuProvider):
    '''Simple Caja extension to Send To Desktop files.'''

    def __init__(self):
        GObject.Object.__init__(self)

    # Choosing the file/directory
    def get_file_items(self, window, files):
        global filelist
        global pwd
        pwd = None
        filelist = []
        for file in files:
            if pwd == None:  # first file: find path to directory
                pwd = file.get_parent_location().get_path()
            name = file.get_name()
            filelist += [name]

        if pwd == None or len(filelist) == 0:
            return

        # Make sure that the user has write permissions in this directory
        elif not os.access(pwd, os.W_OK):
            return
        text = _("_Move to ...")
        item = Caja.MenuItem(
            name='MoveToExplore::Move_to_explore',
            label=text,
            tip=text,
                        icon=""
        )
        item.connect('activate', self.move_file, file)
        return [item]


    def move_file(self, menu, file):
        win = InfoClass()
        dest = win.choose_folder_dialog(self)
        if dest != "":
            for filename in filelist:
                path = pwd + "/" + filename
                if path == f"{dest}/{filename}":
                    text = _("Attempt to move to the current directory")
                    win.print_error(text)
                elif os.path.exists(f"{dest}/{filename}"):
                    cmd = ["/usr/bin/rm", "-rf", f"{dest}/{filename}"]
                    subprocess.call(cmd)
                    cmd = ["/usr/bin/mv", path, f"{dest}"]
                    win = Async_gui(cmd, False)
                    win.connect("destroy", Gtk.main_quit)
                    win.show_all()
                    Gtk.main()
                else:
                    cmd = ["/usr/bin/mv", path, f"{dest}"]
                    win = Async_gui(cmd, False)
                    win.connect("destroy", Gtk.main_quit)
                    win.show_all()
                    Gtk.main()

class InfoClass(Gtk.Window):
    def __init__(self):
        Gtk.Window.__init__(self)
        box = Gtk.Box()
        self.add(box)

    def choose_folder_dialog(self, widget):
        text1 = _("Select directory(s)")
        text2 = _("Select directory")
        dialog = Gtk.FileChooserDialog(text1, self,
                                       Gtk.FileChooserAction.SELECT_FOLDER,
                                       (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL,
                                        text2, Gtk.ResponseType.OK))

        dialog.set_default_size(800, 400)
        response = dialog.run()
        if response == Gtk.ResponseType.OK:
            file_name = dialog.get_filename()
            dialog.destroy()
            return file_name
        else:
            dialog.destroy()
            return ""

    def print_error(self, error):
        dialog = Gtk.MessageDialog(self, 0, Gtk.MessageType.ERROR, Gtk.ButtonsType.CANCEL, "")
        text = _("<b>Error</b>")
        dialog.set_markup(text)
        dialogBox = dialog.get_content_area()
        dialog.set_resizable(True)
        dialog.set_size_request(300, 60)
        dialogBox.set_spacing(10)
        label = Gtk.Label()
        label.set_text(f"   {error}    ")
        dialogBox.pack_start(label, True, True, 0)
        dialog.show_all()
        dialog.run()
        dialog.destroy()


class Async_gui(Gtk.ApplicationWindow):
    def __init__(self, cmd, exist):
        super(Async_gui, self).__init__()
        self.cmd = cmd
        self.exist = exist
        self.set_position(Gtk.WindowPosition.CENTER)

        self.set_default_size(300, 100)
        self.set_border_width(5)
        hb = Gtk.HeaderBar()
        hb.set_show_close_button(False)
        self.set_titlebar(hb)
        main_box = Gtk.Box(orientation=Gtk.Orientation.VERTICAL, spacing=6)
        listbox = Gtk.ListBox()
        listbox.set_selection_mode(Gtk.SelectionMode.NONE)

        main_box.pack_start(listbox, True, True, 0)
        self.set_title("")
        ###############################################
        row = Gtk.ListBoxRow()
        hbox = Gtk.Box(orientation=Gtk.Orientation.VERTICAL, spacing=15)
        text = _("The file exists. Replace?")
        self.label = Gtk.Label(text)
        font = Pango.FontDescription("Tahoma 16")
        self.label.override_font(font)
        hbox.pack_start(self.label, True, True, 0)
        self.spinner = Gtk.Spinner()
        hbox.pack_end(self.spinner, True, True, 0)
        row.add(hbox)
        listbox.add(row)
        ###############################################
        row = Gtk.ListBoxRow()
        hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL, spacing=15)
        text = _("Yes")
        self.button_update = Gtk.Button.new_with_label(text)
        self.button_update.connect("clicked", self.button_update_clicked)
        hbox.pack_start(self.button_update, True, True, 0)
        text = _("Close")
        self.button_close = Gtk.Button.new_with_label(text)
        self.button_close.connect("clicked", self.button_close_clicked)
        hbox.pack_start(self.button_close, True, True, 0)
        row.add(hbox)
        listbox.add(row)
        ###############################################
        self.add(main_box)
        if not self.exist:
            self.call_async()

    def button_update_clicked(self, button):
        self.call_async()

    def call_async(self):
        self.spinner.start()
        text = _("A background process has started\nPlease wait for it to complete")
        self.label.set_text(text)
        self.set_position(Gtk.WindowPosition.CENTER)
        self.button_update.set_sensitive(False)
        self.button_close.set_sensitive(False)

        def thread_run():
            GLib.idle_add(cleanup, self.comd())

        def cleanup(s):
            try:
                t.join()
                self.button_close.set_sensitive(True)
                self.spinner.stop()
                text = _("Operation completed")
                self.label.set_text(text)
                self.resize(300, 120)
                self.destroy()
            except Exception as ex:
                self.button_close.set_sensitive(True)
                self.spinner.stop()
                text = _("Something went wrong:")
                self.label.set_text(f"{text}{ex}")
                self.resize(300, 120)

        t = threading.Thread(None, thread_run)
        t.start()

    def comd(self):
        subprocess.call(self.cmd)

    def button_close_clicked(self, button):
        self.destroy()
