import os
import subprocess
from gi.repository import Caja, GObject
from pathlib import Path
import stat
from pathlib import Path
import gettext
import urllib.parse

t = gettext.translation('send_fm', "/usr/share/locale/")
t.install()
_ = t.gettext
DESKTOP_NAME = os.popen("grep XDG_DESKTOP_DIR $HOME/.config/user-dirs.dirs | awk -F/ '{print $2}'").readline().strip()[:-1]
files_global = []
class SendToDesktop(GObject.GObject, Caja.MenuProvider):
    '''Simple Caja extension to Send To Desktop files.'''

    def __init__(self):
        GObject.Object.__init__(self)

    # Choosing the file/directory
    def get_file_items(self, window, files):
        global filelist
        global pwd
        global files_global
        pwd = None
        filelist = []

        for file in files:
            if pwd == None:  # first file: find path to directory
                pwd = file.get_parent_location().get_path()
            name = file.get_name()
            filelist += [name]
            # files_global += file

        if pwd == None or len(filelist) == 0:
            return

        # Make sure that the user has write permissions in this directory
        elif not os.access(pwd, os.W_OK):
            return
        files_global = files
        text = _("Send to desktop")
        # action for file(s) and directory(ies)
        item = Caja.MenuItem(
            name='SendToDesktop::Send_to_desktop',
            label=text,
            tip=text,
            icon=""
        )
        item.connect('activate', self.send_file, file)
        return [item]

    def send_file(self, menu, file):
        for filename in files_global:
            uri_schema = filename.get_uri_scheme()
            fname = str(urllib.parse.unquote((filename.get_uri()[7:]))).strip()
            if uri_schema != "smb":
                fname = fname.split("/")[-1].strip()
                path = pwd + "/" + fname
                os.symlink(src=path, dst=f"{Path.home()}/{DESKTOP_NAME}/{fname}")
            else:
                uri = filename.get_uri()
                name = fname.split("/")[-1].strip()
                filetype = "folder" if filename.is_directory() else "file"
                splited = uri.split("/")
                rootfolder = "/".join(n for n in splited[0:-1]) if not filename.is_directory() else "/".join(n for n in splited[0:])
                mountfolder = "/".join(n for n in splited[0:4])
                self.make_run_button(uri=uri, name=name, filetype=filetype, rootfolder=rootfolder, mountfolder=mountfolder)

    def make_run_button(self, uri, name, filetype, rootfolder=None, mountfolder=None):
        decoded_uri = str(urllib.parse.unquote(uri))
        exec = f'xdg-open "{decoded_uri}"'
        if filetype == "file" or filetype == "folder":
            decoded_uri = str(urllib.parse.unquote(uri))
            decoded_rootfolder = str(urllib.parse.unquote(rootfolder))
            decoded_mountfolder = str(urllib.parse.unquote(mountfolder))
            sh_btn = '#!/bin/bash\n' \
                     f'mountvar=$(gio info {decoded_mountfolder})\n'\
                     f'if [[ -z "$mountvar" ]]; then\n'\
                     f' timeout 5 caja "{decoded_rootfolder}"\n' \
                     ' pid=$!\n' \
                     ' wait $pid\n' \
                     'fi\n' \
                     f'xdg-open "{decoded_uri}"\n'
            Path(f"{Path.home()}/.local/bin").mkdir(parents=True, exist_ok=True)
            f = open(f"{Path.home()}/.local/bin/{name}.sh", "w")
            f.write(sh_btn)
            f.close()
            os.chmod(f"{Path.home()}/.local/bin/{name}.sh", stat.S_IRWXU)
            exec = f'bash "{Path.home()}/.local/bin/{name}.sh"'
        btn = '#!/usr/bin/env xdg-open\n' \
              '[Desktop Entry]\n' \
              'Version=1.0\n' \
              'Type=Application\n' \
              'Terminal=false\n' \
              f'Icon={filetype}\n' \
              f'Icon[ru_RU]={filetype}\n' \
              f'Exec={exec}\n' \
              f'Name[ru_RU]={name}\n' \
              f'Name={name}\n'
        f = open(f"{Path.home()}/{DESKTOP_NAME}/{name}.desktop", "w")
        f.write(btn)
        f.close()
        os.chmod(f"{Path.home()}/{DESKTOP_NAME}/{name}.desktop", stat.S_IRWXU)

